#pragma once

#include "opensbi/opensbi.h"

namespace drivers {
namespace opensbi::hsm {

    enum class SuspendType : uint32_t {
        RETENTIVE = 0,
        // 0x00000001 - 0x0FFFFFFF: Reserved
        // 0x10000000 - 0x7FFFFFFF: Platform specific retentive
        NON_RETENTIVE = 0x80000000
        // 0x80000001 - 0x8FFFFFFF: Reserved
        // 0x90000000 - 0xFFFFFFFF: Platform specific non-retentive
    };

    SbiRet hart_start(
            unsigned long hartid,
            unsigned long start_addr,
            unsigned long opaque);

    SbiRet hart_stop();

    SbiRet hart_get_status(unsigned long hartid);

    SbiRet hart_suspend(
            SuspendType suspend_type,
            unsigned long resume_addr,
            unsigned long opaque);

}  // End namespace opensbi::hsm
}  // End namespace drivers
